#include "sensor.h"

SFEVL53L1X sensor;

/*
  Reading distance from the laser based VL53L1X
  By: Nathan Seidle
  SparkFun Electronics
  Date: April 4th, 2018
  License: This code is public domain but you buy me a beer if you use this and we meet someday (Beerware license).

  SparkFun labored with love to create this code. Feel like supporting open source hardware?
  Buy a board from SparkFun! https://www.sparkfun.com/products/14667

  This example prints the distance to an object.

  Are you getting weird readings? Be sure the vacuum tape has been removed from the sensor.
*/


//Uncomment the following line to use the optional shutdown and interrupt pins.
//SFEVL53L1X distanceSensor(Wire, SHUTDOWN_PIN, INTERRUPT_PIN);

void SensorVal(float &mm, float &in, float &ft, bool forwardSensor) { // AS OF NOW FORWARD SENSOR DOESN'T DO ANYTHING
  sensor.startRanging(); //Write configuration bytes to initiate measurement
  while (!sensor.checkForDataReady())
  {
    delay(1);
  }
  int distance = sensor.getDistance(); //Get the result of the measurement from the sensor
  sensor.clearInterrupt();
  sensor.stopRanging();

  float distanceMm = distance;

  float distanceInches = distance * 0.0393701;
  float distanceFeet = distanceInches / 12.0;

  mm = distanceMm;
  in = distanceInches;
  ft = distanceFeet;
}

/*bool HitEdge(bool forward) {
  float mm, __;
  SensorVal(mm, __, __, forward);
  return mm > 100;
}*/

void InitializeSensorCommunicationI2C() {
  Wire.begin();

  Serial.begin(115200);
  Serial.println("VL53L1X Qwiic Test");

  if (sensor.begin() != 0) //Begin returns 0 on a good init
  {
    Serial.println("Sensor failed to begin. Please check wiring. Freezing...");
    while (1)
      ;
  }
  Serial.println("Sensor online!");
}