#include "stepper.h"
#include "sensor.h"



void InitializeSteppers() {
  pinMode(StepX,OUTPUT);
  pinMode(DirX,OUTPUT);
  pinMode(StepY,OUTPUT);
  pinMode(DirY,OUTPUT);
  pinMode(StepZ,OUTPUT);
  pinMode( DirZ,OUTPUT);
}

void TurnAxis(float angle, int stepVar, int dirVar, bool clockwise) {
  auto s = clockwise ? HIGH : LOW;
  digitalWrite(dirVar, s);

  int steps = 200 * (angle / 360);

  for(int i = 0; i < steps; i++) { 
    digitalWrite(stepVar,HIGH);
    delayMicroseconds(500);
    digitalWrite(stepVar,LOW); 
    delayMicroseconds(500);
  }
}

void TurnX(float angle, bool clockwise) {TurnAxis(angle, StepX, DirX, clockwise);}

void TurnY(float angle, bool clockwise) {TurnAxis(angle, StepY, DirY, clockwise);}

void TurnXYOpposite(float angle, bool xClockwise) {
  digitalWrite(DirX, xClockwise);
  digitalWrite(DirY, xClockwise);

  int steps = 200 * (angle / 360);

  for(int i = 0; i < steps; i++) { 
    digitalWrite(StepX,HIGH);
    digitalWrite(StepY,HIGH);
    delayMicroseconds(500);
    digitalWrite(StepX,LOW);
    digitalWrite(StepY,LOW); 
    delayMicroseconds(500);
  }
}

void TurnZ(float angle, bool clockwise) {TurnAxis(angle, StepZ, DirZ, clockwise);}