#include "sensor.h"
#include "serial.h"
#include "stepper.h"
#include "logic_lib.h"

const int CALIBRATION_BUTTON_PIN = -1; // TO DO DO THIS //
const int START_BUTTON_PIN = -1; // TO DO DO THIS //
const bool SKIP_CALIBRATION = true; // TO DO DO THIS //
const bool DOWN_ROTATION_Z = true; // TO DO DO THIS //

int currentRotation;
int BOTTOM_ROTATION;
int TOP_ROTATION;

void setup() {
  InitializeSerial();
  InitializeSensorCommunicationI2C();
  InitializeSteppers();
  InitializeLogic(START_BUTTON_PIN);

  if (SKIP_CALIBRATION) return;

  Calibrate(CALIBRATION_BUTTON_PIN, DOWN_ROTATION_Z, BOTTOM_ROTATION, TOP_ROTATION, currentRotation);
}

void loop() {
  WaitForStartup(START_BUTTON_PIN, currentRotation, BOTTOM_ROTATION, TOP_ROTATION, DOWN_ROTATION_Z);
}



void Calibrate(int calibrationButtonPin, bool downRotation, int &_bottomRot, int &_topRot, int &_currentRot) {
  pinMode(calibrationButtonPin, INPUT); // CHECK AND SEE IF PULLUP OR PULLDOWN

  while (digitalRead(calibrationButtonPin) == LOW) { // assumes x and y are the two z motors and z is the wheel motor
    TurnXYOpposite(180, downRotation);
    delay(500);
  }

  int bottomRot = 0;
  int topRot;
  int currentRot = 0;

  while (digitalRead(calibrationButtonPin) == LOW) { // assumes x and y are the two z motors and z is the wheel motor
    TurnXYOpposite(180, !downRotation);
    currentRot += 180; // going up = positive angle
    delay(500);
  }

  topRot = currentRot;

  _bottomRot = bottomRot;
  _topRot = topRot;
  _currentRot = currentRot;
}